/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package simpsons.visitor;

import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;

/**
 *
 * @author pavel
 */
public class CollectDialogReflective {
    public void visit(Object o) throws IllegalAccessException, IllegalArgumentException, InvocationTargetException, NoSuchMethodException {
      // Class.getName() returns package information as well.
      // This strips off the package information giving us
      // just the class name
      String methodName = o.getClass().getName();
      methodName = "visit"+
                   methodName.substring(methodName.lastIndexOf('.')+1);
      // Now we try to invoke the method visit<methodName>
      try {
         // Get the method visitFoo(Foo foo)
         Method m = getClass().getMethod(methodName,
            new Class[] { o.getClass() });
         // Try to invoke visitFoo(Foo foo)
         m.invoke(this, new Object[] { o });
      } catch (NoSuchMethodException e) {
         // No method, so do the default implementation
         throw e;
      }
   }
}
